{
PixaMSN
Copyright (C) 2005 Sergi Martinez (pixador@gmail.com)

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
}

unit UUtils;

//{$DEFINE Debug}

interface

function urldecode(s: string): string;
function urlencode(s: string): string;
function asc2utf(s:string):string;
function utf2asc(s:string):string;
function param(aText: string; aNum: integer): string;
{$IFDEF Debug}
procedure log(aFileName, aText: string);
{$ENDIF}

implementation

uses SysUtils;

function urldecode(s: string): string;
var i: integer;
    k: integer;
begin
  i:=1;
  result:='';
  while (i<=length(s)) do begin
    if s[i]<>'%' then result:=result+s[i]
    else begin
      inc(i);
      k:=(pos(upcase(s[i]), '0123456789ABCDEF')-1)*16;
      inc(i);
      k:=k+(pos(upcase(s[i]), '0123456789ABCDEF')-1);
      result:=result+chr(k);
    end;
    inc(i);
  end;
end;

function urlencode(s: string): string;
var
  i: integer;
begin
  result:='';
  for i:=1 to length(s) do begin
    if (s[i] in ['0'..'9', 'A'..'Z', 'a'..'z']) then result:=result+s[i]
    else result:=result+'%'+inttohex(ord(s[i]), 2);
  end;
end;

function asc2utf(s:string):string;
var t:string;
    i:integer;
begin
     t:='';
     for i:=1 to length(s) do begin
         if ord(s[i])<128 then t:=t+s[i]
         else begin
              t:=t+chr(192+(ord(s[i]) div 64));
              t:=t+chr(128+ord(s[i]) and 63);
         end;
     end;
     asc2utf:=t;
end;

function utf2asc(s:string):string;
var
  t:string;
  i:integer;
begin
  i:=1;
  t:='';
  while i<=length(s) do begin
    if ord(s[i])<128 then t:=t+s[i]
    else begin
      t:=t+chr(((ord(s[i]) and 3)*64)+(ord(s[i+1]) and 63));
      inc(i);
    end;
    if t[length(t)]=#0 then t[length(t)]:=#255;
    inc(i);
  end;
  utf2asc:=t;
end;

function param(aText: string; aNum: integer): string;
var
  i: integer;
  j: integer;
begin
  result:='';
  for i:=2 to aNum do begin
    j:=pos(#32, aText);
    if (j=0) then exit;
    delete(aText, 1, j);
  end;
  j:=pos(#32, aText);
  if (j>0) then aText:=copy(aText, 1, j-1);
  result:=trim(aText);
end;

{$IFDEF Debug}
procedure log(aFileName, aText: string);
var
  f: text;
begin

  AssignFile(f,aFileName);
  try Append(f) except Rewrite(f) end;
  try
    writeln(f, aText);
  finally
  CloseFile(f);
  end;
end;
{$ENDIF}

end.

